opal/util/cmd_line.h File Reference.TH "opal/util/cmd_line.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/util/cmd_line.h \- General command line parsing facility for use throughout Open MPI. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br
\fC#include 'opal/class/opal_list.h'\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef opal_cmd_line_t \fBopal_cmd_line_t\fP"
.br
.ti -1c
.RI "typedef enum \fBopal_cmd_line_type_t\fP \fBopal_cmd_line_type_t\fP"
.br
.ti -1c
.RI "typedef \fBopal_cmd_line_init_t\fP \fBopal_cmd_line_init_t\fP"
.br
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum \fBopal_cmd_line_type_t\fP { \fBOPAL_CMD_LINE_TYPE_NULL\fP, \fBOPAL_CMD_LINE_TYPE_STRING\fP, \fBOPAL_CMD_LINE_TYPE_INT\fP, \fBOPAL_CMD_LINE_TYPE_SIZE_T\fP, \fBOPAL_CMD_LINE_TYPE_BOOL\fP, \fBOPAL_CMD_LINE_TYPE_MAX\fP }"
.br
.RI "\fIData types supported by the parser. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (opal_cmd_line_t)"
.br
.RI "\fITop-level command line handle. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_cmd_line_create\fP (opal_cmd_line_t *cmd, \fBopal_cmd_line_init_t\fP *table)"
.br
.RI "\fIMake a command line handle from a table of initializers. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_cmd_line_make_opt\fP (opal_cmd_line_t *cmd, char short_name, const char *long_name, int num_params, const char *desc)"
.br
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_cmd_line_make_opt3\fP (opal_cmd_line_t *cmd, char short_name, const char *sd_name, const char *long_name, int num_params, const char *desc)"
.br
.RI "\fICreate a command line option. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_cmd_line_parse\fP (opal_cmd_line_t *cmd, bool ignore_unknown, int argc, char **argv)"
.br
.RI "\fIParse a command line according to a pre-built OPAL command line handle. \fP"
.ti -1c
.RI "OMPI_DECLSPEC char * \fBopal_cmd_line_get_usage_msg\fP (opal_cmd_line_t *cmd)"
.br
.RI "\fIReturn a consolidated 'usage' message for a OPAL command line handle. \fP"
.ti -1c
.RI "OMPI_DECLSPEC bool \fBopal_cmd_line_is_taken\fP (opal_cmd_line_t *cmd, const char *opt)"
.br
.RI "\fITest if a given option was taken on the parsed command line. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_cmd_line_get_argc\fP (opal_cmd_line_t *cmd)"
.br
.RI "\fIReturn the number of arguments parsed on a OPAL command line handle. \fP"
.ti -1c
.RI "OMPI_DECLSPEC char * \fBopal_cmd_line_get_argv\fP (opal_cmd_line_t *cmd, int index)"
.br
.RI "\fIReturn a string argument parsed on a OPAL command line handle. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_cmd_line_get_ninsts\fP (opal_cmd_line_t *cmd, const char *opt)"
.br
.RI "\fIReturn the number of instances of an option found during parsing. \fP"
.ti -1c
.RI "OMPI_DECLSPEC char * \fBopal_cmd_line_get_param\fP (opal_cmd_line_t *cmd, const char *opt, int instance_num, int param_num)"
.br
.RI "\fIReturn a specific parameter for a specific instance of a option from the parsed command line. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_cmd_line_get_tail\fP (opal_cmd_line_t *cmd, int *tailc, char ***tailv)"
.br
.RI "\fIReturn the entire 'tail' of unprocessed argv from a OPAL command line handle. \fP"
.in -1c
.SH "Detailed Description"
.PP 
General command line parsing facility for use throughout Open MPI. 

This scheme is inspired by the GNU getopt package. Command line options are registered. Each option can have up to three different matching tokens: a 'short' name, a 'single dash' name, and a 'long' name. Each option can also take 0 or more arguments. Finally, each option can be repeated on the command line an arbitrary number of times.
.PP
The 'short' name can only be a single letter, and will be found after a single dash (e.g., '-a'). Multiple 'short' names can be combined into a single command line argument (e.g., '-abc' can be equivalent to '-a -b -c').
.PP
The 'single dash' name is a multi-character name that only requires a single dash. This only exists to provide backwards compatability for some well-known command line options in prior MPI implementations (e.g., 'mpirun -np 3'). It should be used sparingly.
.PP
The 'long' name is a multi-character name that is found after a pair of dashes. For example, '--some-option-name'.
.PP
A command line option is a combination of 1 or more of a short name, single dash name, and a long name. Any of the names may be used on the command line; they are treated as synonyms. For example, say the following was used in for an executable named 'foo':
.PP
.PP
.nf
 opal_cmd_line_make_opt3(cmd, 'a', NULL, 'add', 1, 'Add a user');
.fi
.PP
.PP
In this case, the following command lines are exactly equivalent:
.PP
.PP
.nf

 * shell$ foo -a jsmith
 * shell$ foo --add jsmith
 * .fi
.PP
.PP
Note that this interface can also track multiple invocations of the same option. For example, the following is both legal and able to be retrieved through this interface:
.PP
.PP
.nf

 * shell$ foo -a jsmith -add bjones
 * .fi
.PP
.PP
The caller to this interface creates a command line handle (opal_cmd_line_t) with OBJ_NEW() and then uses it to register the desired parameters via \fBopal_cmd_line_make_opt3()\fP (or the deprecated \fBopal_cmd_line_make_opt()\fP). Once all the parameters have been registered, the user invokes \fBopal_cmd_line_parse()\fP with the command line handle and the argv/argc pair to be parsed (typically the arguments from main()). The parser will examine the argv and find registered options and parameters. It will stop parsing when it runs into an recognized string token or the special '--' token.
.PP
After the parse has occurred, various accessor functions can be used to determine which options were selected, what parameters were passed to them, etc.:
.PP
.IP "\(bu" 2
\fBopal_cmd_line_get_usage_msg()\fP returns a string suitable for 'help' kinds of messages.
.IP "\(bu" 2
\fBopal_cmd_line_is_taken()\fP returns a true or false indicating whether a given command line option was found on the command line.
.IP "\(bu" 2
\fBopal_cmd_line_get_argc()\fP returns the number of tokens parsed on the handle.
.IP "\(bu" 2
\fBopal_cmd_line_get_argv()\fP returns any particular string from the original argv.
.IP "\(bu" 2
\fBopal_cmd_line_get_ninsts()\fP returns the number of times a particular option was found on a command line.
.IP "\(bu" 2
\fBopal_cmd_line_get_param()\fP returns the Nth parameter in the Mth instance of a given parameter.
.IP "\(bu" 2
\fBopal_cmd_line_get_tail()\fP returns an array of tokens not parsed (i.e., if the parser ran into '--' or an unrecognized token).
.PP
.PP
Note that a shortcut to creating a large number of options exists -- one can make a table of \fBopal_cmd_line_init_t\fP instances and the table to \fBopal_cmd_line_create()\fP. This creates an opal_cmd_line_t handle that is pre-seeded with all the options from the table without the need to repeatedly invoke \fBopal_cmd_line_make_opt3()\fP (or equivalent). This opal_cmd_line_t instance is just like any other; it is still possible to add more options via \fBopal_cmd_line_make_opt3()\fP, etc.
.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC OBJ_CLASS_DECLARATION (opal_cmd_line_t)"
.PP
Top-level command line handle. 
.PP
This handle is used for accessing all command line functionality (i.e., all opal_cmd_line*() functions). Multiple handles can be created and simultaneously processed; each handle is independant from others.
.PP
The opal_cmd_line_t handles are [simplisticly] thread safe; processing is guaranteed to be mutually exclusive if multiple threads invoke functions on the same handle at the same time -- access will be serialized in an unspecified order.
.PP
Once finished, handles should be released with \fBOBJ_RELEASE()\fP. The destructor for opal_cmd_line_t handles will free all memory associated with the handle. 
.SS "OMPI_DECLSPEC int opal_cmd_line_create (opal_cmd_line_t * cmd, \fBopal_cmd_line_init_t\fP * table)"
.PP
Make a command line handle from a table of initializers. 
.PP
\fBParameters:\fP
.RS 4
\fIcmd\fP OPAL command line handle. 
.br
\fItable\fP Table of \fBopal_cmd_line_init_t\fP instances for all the options to be included in the resulting command line handler.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP Upon success.
.RE
.PP
This function takes a table of \fBopal_cmd_line_init_t\fP instances to pre-seed an OPAL command line handle. The last instance in the table must have '' for the short name and NULL for the single-dash and long names. The handle is expected to have been OBJ_NEW'ed or OBJ_CONSTRUCT'ed already.
.PP
Upon return, the command line handle is just like any other. A sample using this syntax:
.PP
.PP
.nf
 opal_cmd_line_init_t cmd_line_init[] = {
    { NULL, NULL, NULL, 'h', NULL, 'help', 0, 
      &orterun_globals.help, OPAL_CMD_LINE_TYPE_BOOL,
      'This help message' },

    { NULL, NULL, NULL, '\0', NULL, 'wd', 1,
      &orterun_globals.wd, OPAL_CMD_LINE_TYPE_STRING,
      'Set the working directory of the started processes' },

    { NULL, NULL, NULL, '\0', NULL, NULL, 0,
      NULL, OPAL_CMD_LINE_TYPE_NULL, NULL }
 };
.fi
.PP
 
.SS "OMPI_DECLSPEC int opal_cmd_line_get_argc (opal_cmd_line_t * cmd)"
.PP
Return the number of arguments parsed on a OPAL command line handle. 
.PP
\fBParameters:\fP
.RS 4
\fIcmd\fP A pointer to the OPAL command line handle.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP If cmd is NULL. 
.br
\fIargc\fP Number of arguments previously added to the handle.
.RE
.PP
Arguments are added to the handle via the \fBopal_cmd_line_parse()\fP function. 
.SS "OMPI_DECLSPEC char* opal_cmd_line_get_argv (opal_cmd_line_t * cmd, int index)"
.PP
Return a string argument parsed on a OPAL command line handle. 
.PP
\fBParameters:\fP
.RS 4
\fIcmd\fP A pointer to the OPAL command line handle. 
.br
\fIindex\fP The nth argument from the command line (0 is argv[0], etc.).
.RE
.PP
\fBReturn values:\fP
.RS 4
\fINULL\fP If cmd is NULL or index is invalid 
.br
\fIargument\fP String of original argv[index]
.RE
.PP
This function returns a single token from the arguments parsed on this handle. Arguments are added bia the \fBopal_cmd_line_parse()\fP function.
.PP
What is returned is a pointer to the actual string that is on the handle; it should not be modified or freed. 
.SS "OMPI_DECLSPEC int opal_cmd_line_get_ninsts (opal_cmd_line_t * cmd, const char * opt)"
.PP
Return the number of instances of an option found during parsing. 
.PP
\fBParameters:\fP
.RS 4
\fIcmd\fP OPAL command line handle. 
.br
\fIopt\fP Short or long name of the option to check for.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fInum\fP Number of instances (to include 0) of a given potion found during \fBopal_cmd_line_parse()\fP.
.br
\fIOMPI_ERR\fP If the command line option was not found during \fBopal_cmd_line_parse()\fP, or \fBopal_cmd_line_parse()\fP was not invoked on this handle.
.RE
.PP
This function should only be called after \fBopal_cmd_line_parse()\fP.
.PP
The function will return the number of instances of a given option (either by its short or long name) -- to include 0 -- or OMPI_ERR if either the option was not specified as part of the OPAL command line handle, or \fBopal_cmd_line_parse()\fP was not invoked on this handle. 
.SS "OMPI_DECLSPEC char* opal_cmd_line_get_param (opal_cmd_line_t * cmd, const char * opt, int instance_num, int param_num)"
.PP
Return a specific parameter for a specific instance of a option from the parsed command line. 
.PP
\fBParameters:\fP
.RS 4
\fIcmd\fP OPAL command line handle. 
.br
\fIopt\fP Short or long name of the option to check for. 
.br
\fIinstance_num\fP Instance number of the option to query. 
.br
\fIparam_num\fP Which parameter to return.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIparam\fP String of the parameter. 
.br
\fINULL\fP If any of the input values are invalid.
.RE
.PP
This function should only be called after \fBopal_cmd_line_parse()\fP.
.PP
This function returns the Nth parameter for the Ith instance of a given option on the parsed command line (both N and I are zero-indexed). For example, on the command line:
.PP
executable --foo bar1 bar2 --foo bar3 bar4
.PP
The call to opal_cmd_line_get_param(cmd, 'foo', 1, 1) would return 'bar4'. opal_cmd_line_get_param(cmd, 'bar', 0, 0) would return NULL, as would opal_cmd_line_get_param(cmd, 'foo', 2, 2);
.PP
The returned string should \fInot\fP be modified or freed by the caller. 
.SS "OMPI_DECLSPEC int opal_cmd_line_get_tail (opal_cmd_line_t * cmd, int * tailc, char *** tailv)"
.PP
Return the entire 'tail' of unprocessed argv from a OPAL command line handle. 
.PP
\fBParameters:\fP
.RS 4
\fIcmd\fP A pointer to the OPAL command line handle. 
.br
\fItailc\fP Pointer to the output length of the null-terminated tail argv array. 
.br
\fItailv\fP Pointer to the output null-terminated argv of all unprocessed arguments from the command line.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERROR\fP If cmd is NULL or otherwise invalid. 
.br
\fIOMPI_SUCCESS\fP Upon success.
.RE
.PP
The 'tail' is all the arguments on the command line that were not processed for some reason. Reasons for not processing arguments include:
.PP
\fBSee also:\fP
.RS 4
The argument was not recognized 
.PP
The argument '--' was seen, and therefore all arguments following it were not processed
.RE
.PP
The output tailc parameter will be filled in with the integer length of the null-terminated tailv array (length including the final NULL entry). The output tailv parameter will be a copy of the tail parameters, and must be freed (likely with a call to \fBopal_argv_free()\fP) by the caller. 
.SS "OMPI_DECLSPEC char* opal_cmd_line_get_usage_msg (opal_cmd_line_t * cmd)"
.PP
Return a consolidated 'usage' message for a OPAL command line handle. 
.PP
\fBParameters:\fP
.RS 4
\fIcmd\fP OPAL command line handle.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIstr\fP Usage message.
.RE
.PP
Returns a formatted string suitable for printing that lists the expected usage message and a short description of each option on the OPAL command line handle. Options that passed a NULL description to \fBopal_cmd_line_make_opt()\fP will not be included in the display (to allow for undocumented options).
.PP
This function is typically only invoked internally by the \fBopal_show_help()\fP function.
.PP
This function should probably be fixed up to produce prettier output.
.PP
The returned string must be freed by the caller. 
.SS "OMPI_DECLSPEC bool opal_cmd_line_is_taken (opal_cmd_line_t * cmd, const char * opt)"
.PP
Test if a given option was taken on the parsed command line. 
.PP
\fBParameters:\fP
.RS 4
\fIcmd\fP OPAL command line handle. 
.br
\fIopt\fP Short or long name of the option to check for.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fItrue\fP If the command line option was found during \fBopal_cmd_line_parse()\fP.
.br
\fIfalse\fP If the command line option was not found during \fBopal_cmd_line_parse()\fP, or \fBopal_cmd_line_parse()\fP was not invoked on this handle.
.RE
.PP
This function should only be called after \fBopal_cmd_line_parse()\fP.
.PP
The function will return true if the option matching opt was found (either by its short or long name) during token parsing. Otherwise, it will return false. 
.SS "OMPI_DECLSPEC int opal_cmd_line_make_opt (opal_cmd_line_t * cmd, char short_name, const char * long_name, int num_params, const char * desc)"
.PP
\fBDeprecated\fP
.RS 4
.RE
.PP
Create a command line option.
.PP
This function is an older [deprecated] form of \fBopal_cmd_line_make_opt3()\fP. It is exactly equivalent to opal_cmd_line_make_opt3(cmd, short_name, NULL, long_name, num_params, desc). 
.SS "OMPI_DECLSPEC int opal_cmd_line_make_opt3 (opal_cmd_line_t * cmd, char short_name, const char * sd_name, const char * long_name, int num_params, const char * desc)"
.PP
Create a command line option. 
.PP
\fBParameters:\fP
.RS 4
\fIcmd\fP OPAL command line handle. 
.br
\fIshort_name\fP 'Short' name of the command line option. 
.br
\fIsd_name\fP 'Single dash' name of the command line option. 
.br
\fIlong_name\fP 'Long' name of the command line option. 
.br
\fInum_params\fP How many parameters this option takes. 
.br
\fIdest\fP Short string description of this option.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_ERR_OUT_OF_RESOURCE\fP If out of memory. 
.br
\fIOMPI_ERR_BAD_PARAM\fP If bad parameters passed. 
.br
\fIOMPI_SUCCESS\fP Upon success.
.RE
.PP
Adds a command line option to the list of options that a a OPAL command line handle will accept. The short_name may take the special value '' to not have a short name. Likewise, the sd_name and long_name may take the special value NULL to not have a single dash or long name, respectively. However, one of the three must have a name.
.PP
num_params indicates how many parameters this option takes. It must be greater than or equal to 0.
.PP
Finally, desc is a short string description of this option. It is used to generate the output from \fBopal_cmd_line_get_usage_msg()\fP. 
.SS "OMPI_DECLSPEC int opal_cmd_line_parse (opal_cmd_line_t * cmd, bool ignore_unknown, int argc, char ** argv)"
.PP
Parse a command line according to a pre-built OPAL command line handle. 
.PP
\fBParameters:\fP
.RS 4
\fIcmd\fP OPAL command line handle. 
.br
\fIignore_unknown\fP Whether to print an error message upon finding an unknown token or not 
.br
\fIargc\fP Length of the argv array. 
.br
\fIargv\fP Array of strings from the command line.
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOPAL_SUCCESS\fP Upon success.
.RE
.PP
Parse a series of command line tokens according to the option descriptions from a OPAL command line handle. The OPAL command line handle can then be queried to see what options were used, what their parameters were, etc.
.PP
If an unknown token is found in the command line (i.e., a token that is not a parameter or a registered option), the parsing will stop (see below). If ignore_unknown is false, an error message is displayed. If ignore_unknown is true, the error message is not displayed.
.PP
The contents of argc and argv are not changed during parsing. argv[0] is assumed to be the executable name, and is ignored during parsing. It can later be retrieved with
.PP
Parsing will stop in the following conditions:
.PP
.IP "\(bu" 2
all argv tokens are processed
.IP "\(bu" 2
the token '--' is found
.IP "\(bu" 2
an unrecognized token is found
.PP
.PP
Upon any of these conditions, any remaining tokens will be placed in the 'tail' (and therefore not examined by the parser), regardless of the value of ignore_unknown. The set of tail tokens is available from the \fBopal_cmd_line_get_tail()\fP function.
.PP
Note that '--' is ignored if it is found in the middle an expected number of arguments. For example, if '--foo' is expected to have 3 arguments, and the command line is:
.PP
executable --foo a b -- other arguments
.PP
This will result in an error, because '--' will be parsed as the third parameter to the first instance of 'foo', and 'other' will be an unrecognized option.
.PP
Invoking this function multiple times on different sets of argv tokens is safe, but will erase any previous parsing results. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
